abuild.in 34.6 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23
APK=${APK:-apk}
24
apk_opt_wait="--wait 30"
25

Natanael Copa's avatar
Natanael Copa committed
26
# read config
Natanael Copa's avatar
Natanael Copa committed
27
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
28 29
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

30
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
31 32 33 34 35 36
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
37 38 39 40 41 42 43 44 45 46 47 48 49 50
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
Natanael Copa's avatar
Natanael Copa committed
75 76

	
Linux User's avatar
Linux User committed
77
set_xterm_title() {
78
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
79
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
80 81 82 83 84
	fi
} 

cleanup() {
	set_xterm_title ""
85
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
86 87
		msg "Uninstalling dependencies..."
		$SUDO $APK del --quiet $apk_opt_wait $uninstall_after
88
	fi
Linux User's avatar
Linux User committed
89 90
}

Natanael Copa's avatar
Natanael Copa committed
91
die() {
Linux User's avatar
Linux User committed
92
	error "$@"
Linux User's avatar
Linux User committed
93
	cleanup
Natanael Copa's avatar
Natanael Copa committed
94 95 96
	exit 1
}

97 98
# check if apkbuild is basicly sane
sanitycheck() {
99
	local i= j= suggestion=
100
	msg "Checking sanity of $APKBUILD..."
101 102 103
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
104
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
105
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
106 107
			die "$pkgver is not a valid version"
	fi
108
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
109 110 111 112
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

113 114 115 116 117 118 119 120 121 122
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
123
	for i in $install; do
124
		local n=${i%.*}
125
		local suff=${i##*.}
126 127 128 129 130
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
131
			die "$i: install script does not match pkgname or any subpackage"
132
		fi
133
		[ -e "$startdir/$i" ] || die "install script $i is missing"
Natanael Copa's avatar
Natanael Copa committed
134 135
	done
	
136 137 138 139 140 141 142 143
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
		[ "$f" = "$i" ] && die "$f: triggers must contain '='" 
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
144

145 146
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
147 148
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
149 150 151 152
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
153
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
154 155 156
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
157 158
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
159

160 161
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
162
			source_has $i || die "$i exists in md5sums but is missing in source"
163 164
		done
	fi
165

166 167 168
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
169 170

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
171 172

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
173 174 175 176
	return 0
}

md5check() {
177
	local dummy f endreturnval originalparams origin file
178 179 180
	if [ -z "$source" ]; then
		return 0
	fi
181
	if [ -z "$md5sums" ]; then
182
		die "Use 'abuild checksum' to generate/update the checksum(s)"
183
	fi
184 185 186
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
187
	fetch || return 1
188
	msg "Checking md5sums..."
Natanael Copa's avatar
Natanael Copa committed
189
	cd "$srcdir" || return 1
190 191 192 193 194 195 196 197
	IFS=$'\n'
	endreturnval=0
	originalparams=$@
	set -- $source
	for src in $md5sums; do
		origin=$1; shift
		echo "$src" | md5sum -c
		if [ $? -ne 0 ]; then
198
			endreturnval=1
199 200 201 202 203 204 205 206 207 208 209
			is_remote $origin || continue
			echo "Because the remote file above failed the md5sum check it will be deleted."
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	set -- $originalparams
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
210 211
}

Natanael Copa's avatar
Natanael Copa committed
212 213
# verify upstream sources
sourcecheck() {
214 215 216 217 218 219 220 221 222 223
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
224
	done
225
	return 0
Natanael Copa's avatar
Natanael Copa committed
226
}
227

Natanael Copa's avatar
Natanael Copa committed
228 229
uri_fetch() {
	local uri="$1"
230
	local d="${uri##*/}"	# $(basename $uri)
231 232 233 234
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

235 236 237 238 239
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
Natanael Copa's avatar
Natanael Copa committed
240
	esac
241 242 243 244 245

	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
Natanael Copa's avatar
Natanael Copa committed
246
	
Natanael Copa's avatar
Natanael Copa committed
247
	mkdir -p "$SRCDEST"
248 249 250
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
251
	fi
Linux User's avatar
Linux User committed
252
	msg "Fetching $uri"
253 254
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
255 256
}

257 258
is_remote() {
	case "$1" in
259
		http://*|ftp://*|https://*|saveas-*://*)
260 261 262 263 264
			return 0;;
	esac
	return 1
}

265 266 267 268 269
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
270 271 272 273 274
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
275 276 277 278
	fi
	uri_fetch "$uri"
}

279
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
280 281
	local s
	mkdir -p "$srcdir"
282 283
	for s in $source; do
		if is_remote "$s"; then
284
			uri_fetch_mirror "$s" || return 1
285 286 287 288
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
289 290 291
	done
}

292 293 294 295
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
296 297 298 299 300 301 302 303 304 305 306 307 308 309 310
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
311
# unpack the sources
312
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
313
	local u
314 315
	if [ -z "$force" ]; then
		md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
316
		initdcheck || return 1
317
	fi
Natanael Copa's avatar
Natanael Copa committed
318 319 320 321
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
322
			*.tar.gz|*.tgz)
323
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
324 325
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
326
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
327
				tar -C "$srcdir" -jxf "$s" || return 1;;
328 329 330 331
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
332 333 334
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
335 336 337
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
338 339 340 341
		esac
	done
}

342 343 344 345
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
346 347
# cleanup source and package dir
clean() {
348
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
349
	rm -rf "$srcdir"
350
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
351 352 353 354 355 356
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
357 358 359 360
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
361 362 363
	done
}

364 365 366 367 368 369 370 371 372 373
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
374 375
cleanpkg() {
	local i
376
	getpkgver || return 1
377
	msg "Cleaning built packages..."
378
	for i in $(listpkgnames); do
379 380
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
381
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
382
	done
383
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
384 385
}

386 387 388
# clean all packages except current
cleanoldpkg() {
	local i j
389
	getpkgver || return 1
390
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
391
	for i in $(listpkgnames); do
392 393 394 395 396
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
397 398 399 400
		done
	done
	return 0
}
401 402 403 404 405

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
406
			local gopt=
407
			msg "Creating user $i"
408 409 410 411
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
			$SUDO adduser -D -H $gopt $i || return 1
412 413 414 415 416 417 418 419 420 421 422
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
423 424
runpart() {
	local part=$1
425
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
426 427 428 429
	$part || die "$part failed"
}

# override those in your build script
430 431 432 433 434 435 436 437
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
438 439 440 441
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
442
build() {
443
	:
Natanael Copa's avatar
Natanael Copa committed
444 445
}

446 447 448
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
449
	mkdir -p "$PKGDEST"
450 451 452
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
453 454 455 456 457 458 459 460 461
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

462
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
463 464
	local i
	cd "$startdir"
465
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
466 467
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
468
		msg "Running split function $func..."
469
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
470
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
471
	done
472 473 474 475 476 477 478
	# post check
	i=$(find "$pkgdir" -name '*.la')
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
		echo "$i" | sed 's/^/  /'
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
479 480
}

481 482 483 484 485 486 487 488 489 490 491 492 493 494 495
default_lang() {
	pkgname="Languages for package $pkgname"
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

496
default_lang_subpkg() {
497 498 499 500
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
501
	pkgdesc="$pkgname language pack for $lang"
502 503
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
504 505 506 507 508
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
509
		|| return 1
510 511 512 513 514
	done
}

lang_subpkg() {
	default_lang_subpkg
515 516 517 518 519 520 521 522 523 524 525
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

526 527 528 529 530 531 532 533 534 535 536 537
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

538 539 540 541 542 543
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

544
prepare_metafiles() {
545
	getpkgver || return 1
546 547
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
548
	local dir=${subpkgdir:-$pkgdir}
549
	local pkg="$name-$pkgver-r$pkgrel.apk"
550
	local pkginfo="$controldir"/.PKGINFO
551
	local sub
Natanael Copa's avatar
Natanael Copa committed
552 553 554
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
555
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
556 557
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
558
	local parch="$CARCH"
559 560 561 562 563

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
564

565
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
566
	if [ -n "$FAKEROOTKEY" ]; then
567
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
568
	fi
569 570
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
571
pkgname = $name
572
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
573 574 575 576 577
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
578
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
579
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
580
EOF
581 582
	local i deps
	deps="$depends"
583
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
584 585
		for i in $install $triggers; do
			local s=${i%=*}
586
			[ "$name" != "${s%.*}" ] && continue
587
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
588 589 590 591 592
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
593 594
	fi
	
595 596 597 598 599 600 601 602 603 604
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

Natanael Copa's avatar
Natanael Copa committed
605
	for i in $license; do
606
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
607 608
	done
	for i in $replaces; do
609
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
610
	done
611
	for i in $deps; do
612
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
613 614
	done
	for i in $conflicts; do
615
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
616 617
	done
	for i in $provides; do
618
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
619
	done
620 621 622 623 624 625
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
626 627 628
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
629 630

	local metafiles=".PKGINFO"
631 632 633
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
634
		if [ "$n" != "$name" ]; then
635 636
			continue
		fi
637
		script=${f#$name}
638
		msg "Adding $script"
639
		cp "$startdir/$f" "$controldir/$script" || return 1
640
		chmod +x "$controldir/$script"
641 642
		metafiles="$metafiles $script"
	done
643
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
644
}
645

646 647
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
648
	[ "$arch" = "noarch" ] && return 0
649
	options_has "!tracedeps" && return 0
650
	# lets tell all the .so files this package provides in .provides-so
651 652
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
653 654 655 656 657
	# lets tell all the places we should look for .so files - all rpaths
	scanelf -q -Rr "$dir" | sed -e 's/[[:space:]].*//' -e 's/:/\n/' \
		| sort | uniq \
		>"$controldir"/.rpaths
	# now find the so dependencies
658
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
659 660 661
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
662 663
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
664
	done
Natanael Copa's avatar
Natanael Copa committed
665 666
}

667 668 669 670 671 672 673 674 675 676 677 678
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

679 680 681 682 683
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

684 685 686 687 688 689 690
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
691 692 693
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
694 695 696 697
	fi
	return 0
}

698
prepare_package() {
699
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
700
	stripbin
701 702
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
703 704 705 706 707 708 709 710
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

711 712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727 728 729 730 731 732 733
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

734 735 736
trace_apk_deps() {
	local name="$1"
	local dir="$2"
Natanael Copa's avatar
Natanael Copa committed
737
	local i= j= found= autodeps= deppkgs= missing= so_paths= self_provided=
738
	msg "Tracing dependencies for $name..."
739 740 741
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
742
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
743 744 745 746
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
747
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
748 749
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
750
		msg "  added libgcc (due to libpthread)"
751
	fi
752
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
753
		found=
754
		# first check if its provide by same apkbuild
755
		for j in "$dir"/../.control.*/.provides-so; do
756
			grep -w "$i" "$j" >/dev/null || continue
757
			found=${j%/.provides-so}
758
			found=${found##*/.control.}
759
			break
760
		done
761 762 763 764 765 766
		if [ -n "$found" ]; then
			if ! list_has "$found" $self_provided; then
				self_provided="$self_provided $found"
			fi
		else
			missing="$missing $i"
767
		fi
768 769 770
	done

	# find all packages that holds the so files
771 772 773 774 775
	if [ -f "$dir"/.rpaths ]; then
		so_files=$(find_so_files "$dir"/.rpaths $missing) || return 1
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

776
	for found in $self_provided $deppkgs; do
777
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
778 779 780
			warning "You can remove '$found' from depends"
			continue
		fi
781 782
		if [ "$found" != "$name" ] && ! list_has "$found" $autodeps; then
			autodeps="$autodeps $found"
783
			msg "  added $found"
784
		fi
785
	done
786

787 788 789 790 791 792 793
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

794 795
create_apks() {
	local file
796
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
797
	mkdir -p "$PKGDEST"
798
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
799 800 801
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
802
		local apk=$name-$ver.apk
803
		local datadir="$pkgbasedir"/$name
804 805

		trace_apk_deps "$name" "$dir" || return 1
806
		msg "Creating $apk..."
807
		(
808 809
		cd "$datadir"
		# data.tar.gz
810 811 812 813 814 815
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
816 817 818 819 820 821

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
822
		cd "$dir"
823 824
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
825
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
826

827 828 829
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
830 831 832
	done
}

833
clean_abuildrepo() {
834
	local apk
835 836 837
	cd "$abuildrepo" || return 1
	
	# remove compat symlink
838
	for d in "$abuildrepo/$CARCH"; do
839 840
		[ -L "$d" ] && rm "$d"
	done
841

842 843
	# remove broken links from abuildrepo
	for apk in *.apk */*.apk; do
844 845 846 847
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done
848
}
849

850
mklinks_abuildrepo() {
851 852
	local apk
	mkdir -p "$abuildrepo"/$CARCH
853
	cd "$abuildrepo" || return 1
854
	# create links for this package
855
	for apk in $(listpkg); do
856
		[ -f "$PKGDEST"/$apk ] || continue
857
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$CARCH/$apk
858
	done
859 860 861 862 863 864 865 866 867 868 869 870 871 872
}

update_abuildrepo() {
	local d apk
	if ! apk_up2date || [ -n "$force" ]; then
		sanitycheck && builddeps && clean && fetch && unpack \
			&& prepare && mkusers && rootpkg || return 1
	fi

	clean_abuildrepo
	mklinks_abuildrepo

	cd "$abuildrepo"
	local index=$CARCH/APKINDEX.tar.gz
873

874
	msg "Updating the cached abuild repository index..."
875 876
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
877 878
	if [ -f "$index" ]; then
		oldindex="--index $index"
879
	fi
880
	$APK index --quiet $oldindex --output "$index".unsigned \
881
		--description "$repo $(cd $startdir && git describe)" \
882 883
		--rewrite-arch $CARCH \
		$CARCH/*.apk || exit 1
884
	msg "Signing the index..."
885 886 887
	abuild-sign -q "$index".unsigned || exit 1
	mv "$index".unsigned "$index"
	chmod 644 "$index"
888 889
}

890
# predefined splitfunc doc
891
default_doc() {
892
	depends="$depends_doc"
893
	pkgdesc="$pkgdesc (documentation)"
894
	arch=${arch_doc:-"noarch"}
895

Natanael Copa's avatar
Natanael Copa committed
896
	local i
897
	for i in doc man info html sgml licenses gtk-doc; do
898 899 900
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
901 902
		fi
	done
903 904 905
	
	rm -f "$subpkgdir/usr/share/info/dir"

906 907 908
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
909 910 911 912

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
913
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
914 915 916
	return 0
}

917 918 919 920
doc() {
	default_doc
}

921
# predefined splitfunc mod
922
default_mod() {
923
	depends="$kernel $depends_mod"
Natanael Copa's avatar
Natanael Copa committed
924
	for i in firmware modules; do
925 926 927
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
928
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
929 930 931 932
		fi
	done
}

933 934 935 936
mod() {
	default_mod
}

937
# predefined splitfunc dev
938
default_dev() {
939
	local i= j=
940
	depends="$pkgname $depends_dev"
941 942
	pkgdesc="$pkgdesc (development files)"

943 944 945 946
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
947
	cd "$pkgdir" || return 0
948 949
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
950
			usr/share/vala/vapi usr/share/gir-[0-9]*\
951
			$(find -name include -type d) 		\
952
			$(find usr/ -name '*.[acho]' 2>/dev/null); do
953 954
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
955
			mkdir -p "$d"
956
			mv "$pkgdir/$i" "$d"
957
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
958 959
		fi
	done
960 961 962 963 964 965 966
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
967
	return 0
Natanael Copa's avatar
Natanael Copa committed
968 969
}

970 971 972 973
dev() {
	default_dev
}

974 975 976 977
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

978 979 980 981 982 983 984 985
do_fakeroot() {
	if [ -n "$FAKEROOT" ]; then
		$FAKEROOT -- "$@"
	else
		"$@"
	fi
}

Natanael Copa's avatar
Natanael Copa committed
986 987
# build and package in fakeroot
rootpkg() {
988 989 990 991
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
992
		do_build=package
993
	fi
Natanael Copa's avatar
Natanael Copa committed
994
	cd "$startdir"
995
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
996
	do_fakeroot "$abuild_path" $color_opt $do_build \
997
		prepare_subpackages \
998
		prepare_language_packs \
999
		prepare_package \
1000
		create_apks
Natanael Copa's avatar
Natanael Copa committed
1001 1002 1003
}

srcpkg() {
1004
	getpkgver || return 1
1005
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
1006
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
1007 1008 1009 1010 1011
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
1012
	msg "Creating source package $p.src.tar.gz..."
1013
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
1014 1015
}

Natanael Copa's avatar
Natanael Copa committed
1016 1017
# return true if arch is supported or noarch
check_arch() {
Natanael Copa's avatar
Natanael Copa committed
1018
	list_has $CARCH $arch || [ "$arch" = "noarch" ] || [ "$arch" = "all" ]
Natanael Copa's avatar
Natanael Copa committed
1019 1020
}

1021
# check if package is up to date
1022
apk_up2date() {
1023
	getpkgver || return 1
1024
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
1025
	local i s
Natanael Copa's avatar
Natanael Copa committed
1026
	cd "$startdir"
1027 1028 1029 1030 1031
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

1032
	for i in $source APKBUILD; do
1033 1034 1035 1036 1037 1038
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
1039 1040 1041 1042 1043 1044 1045
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

1046
abuildindex_up2date() {
1047
	local i
1048
	getpkgver || return 1
1049 1050 1051 1052 1053 1054 1055
	local dir="$abuildrepo"/$CARCH
	local apk="${pkgname%:*}-$pkgver-r$pkgrel.apk"
	local idx="$dir"/APKINDEX.tar.gz
	local file="$dir"/$apk

	# check if index is missing
	[ -f "$idx" ] || return 1
1056
			
1057 1058 1059 1060 1061
	# if link or file is missing, then we need update abuildrepo index
	[ -f "$file" ] || return 1

	# if file exists and is newer than index, then we need update index
	[ "$file" -nt "$idx" ] && return 1
1062
		
1063 1064 1065 1066
	return 0
}

up2date() {
Natanael Copa's avatar
Natanael Copa committed
1067
	check_arch || return 0
1068 1069 1070 1071 1072 1073 1074
	apk_up2date && abuildindex_up2date
}

# rebuild package and abuildrepo index if needed
abuildindex() {
	up2date && return 0
	update_abuildrepo
1075 1076
}

1077 1078 1079 1080 1081 1082 1083
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
1084 1085
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/..)
	for i in $aportsdir/*/APKBUILD; do
1086 1087 1088 1089
		pkgname=
		subpackages=
		depends=
		makedepends=
1090
		. $i
1091
		dir=${i%/APKBUILD}
1092
		deps=
1093
		# filter out conflicts from deps and version info
1094 1095 1096 1097
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
1098
			deps="$deps ${j%%[<>=]*}"
1099
		done
1100
		for j in $pkgname $subpackages; do
1101
			echo "o ${j%%:*} $dir"
1102
			set -- $deps
1103 1104 1105 1106 1107 1108 1109
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
1110 1111
		done
	done
1112
	)
1113 1114
}

1115
deptrace() {
1116 1117 1118
	local deps= i=
	# strip versions from deps
	for i in "$@"; do
1119
		deps="$deps ${i%%[<>=]*}"
1120
	done
1121
	[ -z "$deps" ] && return 0
1122 1123 1124
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
1125
			$APK info -q | sort |  sed 's/^/i /'
1126
		fi
1127
	) | awk -v pkgs="$deps" '
1128 1129 1130 1131 1132 1133 1134 1135 1136 1137 1138 1139 1140 1141 1142 1143 1144 1145 1146 1147 1148 1149 1150 1151 1152

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {